
#include <iostream>
#include "DList.h"

int main()
{

   DList<int> a;

   //   
   for (int k=0; k<10; k++) {
      a.PushLast(k);
   }
   cout << "fill list\n";
   cout << a;

   //   
   cout << "print by iterator with increment\n";
   DList<int>::Iterator i; 
   for (i = a.begin(); i != a.end(); ++i) {
      cout << ++(*i) << "  ";
   }
   cout << endl;

   cout << "reverse print by iterator with increment\n";
   for (auto j = a.rbegin(); j != a.rend(); --j) {
      cout << ++(*j) << "  ";
   }
   cout << endl;

   cout << "remove third element\n";
   i = a.begin();
   ++i, ++i;
   cout << a;
   a.RemoveAt(i);
   cout << a;


   cout << "print by const iterator\n";
   const DList<int> & b = a;
   for (auto k = b.begin(); k != b.end(); ++k) {
      cout << (*k) << " - ";
      //cout << ++(*k) << " - ";  // this causes compilation error
   }
   cout << endl;


   return 0;
}